/*
Copyright (c) 2006 Arthur Huillet

TINS'06 entry


Display functions
*/

#include "all_inc.h"
extern int cyclecount;
extern int page_flip;

int render_player()
{
player.sprite = create_bitmap(PLAYER_SIZE * 8, PLAYER_SIZE * 8);
clear_to_color(player.sprite, makecol(255, 0, 255));
for(int i = 0; i < PLAYER_SIZE; i++)
	{
	textprintf_ex(player.sprite, font, 0, 8*i, makecol(255, 255, 255), -1, "%s", player.draw[i]);
	}
return 0;
}

int display_background()
{
for(int x = -(screen_offset.x % 800); x < (signed)RESOL_X; x += 64)
	for(int y = 0-(screen_offset.y % 600); y < (signed)RESOL_Y; y += 64)
		if(x > -64 && y > -64)
			blit(bground, vscreen[page_num], 0, 0, x, y, 64, 64);
return 0;
}

int display_player()
{
int y = -(crosshair.offset_rp.y);
int x = (crosshair.offset_rp.x);
fixed angle = 0;
angle = fixatan2(itofix(x), itofix(y));

//log_msg(3, "X = %i Y = %i angle = %i", x, y, angle >> 16);
pivot_sprite(vscreen[page_num], player.sprite, player.refpt.x - screen_offset.x, player.refpt.y - screen_offset.y, PLAYER_SIZE * 4, PLAYER_SIZE * 4, angle);
//putpixel(vscreen[page_num], player.refpt.x - screen_offset.x, player.refpt.y - screen_offset.y, makecol(255, 0, 0));
//putpixel(vscreen[page_num], player.refpt.x - screen_offset.x + gun_length * cos(gun_angle + angle), player.refpt.y - screen_offset.y + gun_length * sin(gun_angle + angle), makecol(255, 0, 255));
return 0;
}
	
int display_enemies()
{
enemy_t * cur = first_enemy;
while(cur)
	{
	draw_sprite(vscreen[page_num], cur->spr, cur->pos.x - screen_offset.x, cur->pos.y - screen_offset.y);
	cur = cur->NEXT;
	}
cur = first_bomb;
while(cur)
	{
	draw_sprite(vscreen[page_num], cur->spr, cur->pos.x - screen_offset.x, cur->pos.y - screen_offset.y);
//	putpixel(vscreen[page_num], cur->pos.x - screen_offset.x, cur->pos.y - screen_offset.y, makecol(0, 255, 255));
	cur = cur->NEXT;
	}
return 0;
}

int display_crosshair()
{
putpixel(vscreen[page_num], crosshair.offset_rp.x + player.refpt.x - screen_offset.x - 1, crosshair.offset_rp.y + player.refpt.y - screen_offset.y, makecol(255, 0, 0));
putpixel(vscreen[page_num], crosshair.offset_rp.x + player.refpt.x - screen_offset.x + 1, crosshair.offset_rp.y + player.refpt.y - screen_offset.y, makecol(255, 0,0));
putpixel(vscreen[page_num], crosshair.offset_rp.x + player.refpt.x - screen_offset.x, crosshair.offset_rp.y + player.refpt.y - screen_offset.y - 1, makecol(255, 0, 0));
putpixel(vscreen[page_num], crosshair.offset_rp.x + player.refpt.x - screen_offset.x, crosshair.offset_rp.y + player.refpt.y - screen_offset.y + 1, makecol(255, 0, 0));
putpixel(vscreen[page_num], crosshair.offset_rp.x + player.refpt.x - screen_offset.x - 2, crosshair.offset_rp.y + player.refpt.y - screen_offset.y, makecol(255, 50, 0));
putpixel(vscreen[page_num], crosshair.offset_rp.x + player.refpt.x - screen_offset.x + 2, crosshair.offset_rp.y + player.refpt.y - screen_offset.y, makecol(255, 50, 0));
putpixel(vscreen[page_num], crosshair.offset_rp.x + player.refpt.x - screen_offset.x, crosshair.offset_rp.y + player.refpt.y - screen_offset.y - 2, makecol(255, 50, 0));
putpixel(vscreen[page_num], crosshair.offset_rp.x + player.refpt.x - screen_offset.x, crosshair.offset_rp.y + player.refpt.y - screen_offset.y + 2, makecol(255, 50, 0));
putpixel(vscreen[page_num], crosshair.offset_rp.x + player.refpt.x - screen_offset.x - 3, crosshair.offset_rp.y + player.refpt.y - screen_offset.y, makecol(255, 75, 0));
putpixel(vscreen[page_num], crosshair.offset_rp.x + player.refpt.x - screen_offset.x + 3, crosshair.offset_rp.y + player.refpt.y - screen_offset.y, makecol(255, 75, 0));
putpixel(vscreen[page_num], crosshair.offset_rp.x + player.refpt.x - screen_offset.x, crosshair.offset_rp.y + player.refpt.y - screen_offset.y - 3, makecol(255, 75, 0));
putpixel(vscreen[page_num], crosshair.offset_rp.x + player.refpt.x - screen_offset.x, crosshair.offset_rp.y + player.refpt.y - screen_offset.y + 3, makecol(255, 75, 0));
if(player.weap > 0)
	{	
	if(player.weap == 1)
		if(!beam.reload_time)
			rect(vscreen[page_num], crosshair.offset_rp.x + player.refpt.x - screen_offset.x - 4, crosshair.offset_rp.y + player.refpt.y - screen_offset.y - 4, crosshair.offset_rp.x + player.refpt.x - screen_offset.x + 4, crosshair.offset_rp.y + player.refpt.y - screen_offset.y + 4, makecol(255, 127, 0));
	if(player.weap == 2)
		rect(vscreen[page_num], crosshair.offset_rp.x + player.refpt.x - screen_offset.x - 4, crosshair.offset_rp.y + player.refpt.y - screen_offset.y - 4, crosshair.offset_rp.x + player.refpt.x - screen_offset.x + 4, crosshair.offset_rp.y + player.refpt.y - screen_offset.y + 4, makecol(255, 127, 0));
	}
	
if(player.weap > 1)
	{
	putpixel(vscreen[page_num], crosshair.offset_rp.x + player.refpt.x - screen_offset.x - 5, crosshair.offset_rp.y + player.refpt.y - screen_offset.y - 5, makecol(255, 255, 0));
	putpixel(vscreen[page_num], crosshair.offset_rp.x + player.refpt.x - screen_offset.x - 6, crosshair.offset_rp.y + player.refpt.y - screen_offset.y - 6, makecol(255, 255,0));
	putpixel(vscreen[page_num], crosshair.offset_rp.x + player.refpt.x - screen_offset.x + 5, crosshair.offset_rp.y + player.refpt.y - screen_offset.y + 5, makecol(255, 255, 0));
	putpixel(vscreen[page_num], crosshair.offset_rp.x + player.refpt.x - screen_offset.x + 6, crosshair.offset_rp.y + player.refpt.y - screen_offset.y + 6, makecol(255, 255, 0));
	putpixel(vscreen[page_num], crosshair.offset_rp.x + player.refpt.x - screen_offset.x - 5, crosshair.offset_rp.y + player.refpt.y - screen_offset.y + 5, makecol(255, 255, 0));
	putpixel(vscreen[page_num], crosshair.offset_rp.x + player.refpt.x - screen_offset.x - 6, crosshair.offset_rp.y + player.refpt.y - screen_offset.y + 6, makecol(255, 255, 0));
	putpixel(vscreen[page_num], crosshair.offset_rp.x + player.refpt.x - screen_offset.x +5, crosshair.offset_rp.y + player.refpt.y - screen_offset.y - 5, makecol(255, 255, 0));
	putpixel(vscreen[page_num], crosshair.offset_rp.x + player.refpt.x - screen_offset.x +6, crosshair.offset_rp.y + player.refpt.y - screen_offset.y -6, makecol(255, 255, 0));
	}
return 0;
}

int display_railroad()
{
int i = 0;
railpart * cur = railroad;
while(i < (signed)current_year - 110)
	{
	cur = cur->NEXT;
	i += 10;
	}

while((i < (signed)current_year + 120) && cur)
	{
	switch(cur->part)
		{
		case '-' : draw_sprite(vscreen[page_num], part_sprites.dash, cur->pos.x - screen_offset.x, cur->pos.y - screen_offset.y); break;
		case '|' : draw_sprite(vscreen[page_num], part_sprites.pipe, cur->pos.x - screen_offset.x, cur->pos.y - screen_offset.y); break;
		case 'V' : draw_sprite(vscreen[page_num], part_sprites.pipe, cur->pos.x - screen_offset.x, cur->pos.y - screen_offset.y); break;
		case '/' : draw_sprite(vscreen[page_num], part_sprites.slash, cur->pos.x - screen_offset.x, cur->pos.y - screen_offset.y);break;
		case '\\': draw_sprite(vscreen[page_num], part_sprites.antislash, cur->pos.x - screen_offset.x, cur->pos.y - screen_offset.y); break;
		}
	i+=10; 
	cur = cur->NEXT;
	}
pivot_sprite(vscreen[page_num], train, tpos.x - screen_offset.x, tpos.y - screen_offset.y, 68, 18, train_angle);
return 0;
}

int display_hud()
{
textout_ex(vscreen[page_num], font, "/", 0, RESOL_Y - 64, makecol(255, 255, 255), -1);
textout_ex(vscreen[page_num], font, "\\", RESOL_X - 8, RESOL_Y - 64, makecol(255, 255, 255), -1);
textout_ex(vscreen[page_num], font, "\\", 0, RESOL_Y - 8, makecol(255, 255, 255), -1);
textout_ex(vscreen[page_num], font, "/", RESOL_X - 8, RESOL_Y - 8, makecol(255, 255, 255), -1);
for(unsigned int y = RESOL_Y - 56; y < RESOL_Y - 8; y += 8)
	{
	textout_ex(vscreen[page_num], font, "|", -3, y, makecol(255, 255, 255), -1);
	textout_ex(vscreen[page_num], font, "|", RESOL_X - 6, y, makecol(255, 255, 255), -1);
	}

textprintf_ex(vscreen[page_num], font, 12, RESOL_Y - 56, makecol(255, 255, 255), makecol(0,0,0), "Year");
textprintf_ex(vscreen[page_num], font, 52, RESOL_Y - 56, makecol(255, 0, 0), makecol(0,0,0), "%i", current_year);
textprintf_ex(vscreen[page_num], font, 12, RESOL_Y - 46, makecol(255, 255, 255), makecol(0,0,0), "Fate points");
textprintf_ex(vscreen[page_num], font, 108, RESOL_Y - 46, makecol(0, 255, 255), makecol(0,0,0), "%i", life);
textprintf_ex(vscreen[page_num], font, 12, RESOL_Y - 20, makecol(255, 255, 255), makecol(0,0,0), "Difficulty:");
switch(difficulty_level)
	{
	case 0: textprintf_ex(vscreen[page_num], font, 108, RESOL_Y - 20, makecol(255, 192, 255), makecol(0,0,0), "easy"); break;
	case 1: textprintf_ex(vscreen[page_num], font, 108, RESOL_Y - 20, makecol(255, 127, 255), makecol(0,0,0), "medium"); break;
	case 2: textprintf_ex(vscreen[page_num], font, 108, RESOL_Y - 20, makecol(255, 63, 127), makecol(0,0,0), "hard"); break;
	case 3: textprintf_ex(vscreen[page_num], font, 108, RESOL_Y - 20, makecol(255, 0, 0), makecol(0,0,0), "insane"); break;
	}

if(defuse_time >= 0)
	{
	textout_ex(vscreen[page_num], font, "Defusing bomb ... ", 250, RESOL_Y - 52, makecol(255 * (80 - defuse_time) / 80, 255 * defuse_time / 80, 0), -1);
	rect(vscreen[page_num], 400, RESOL_Y - 54, 500, RESOL_Y - 39, makecol(255 * (80 - defuse_time) / 80, 255 * defuse_time / 80, 0));
	rectfill(vscreen[page_num], 400, RESOL_Y - 54, 500 - ((80 - defuse_time) * 100 / 80), RESOL_Y - 39, makecol(255 * (80 - defuse_time) / 80, 255 * defuse_time / 80, 0));
	}
textprintf_ex(vscreen[page_num], font, 250, RESOL_Y - 20, makecol(255, 255, 255), -1, "Weapon:");
char weap_name[20];
memset(weap_name, 0, 20);
if(player.weap == 0 || beam.reload_time > 0) sprintf(weap_name, "standard gun");
if(player.weap == 1 && !beam.reload_time) sprintf(weap_name, "Eradicator Beam");
if(player.weap == 2) sprintf(weap_name, "ASCII Garbagethrower");
textprintf_ex(vscreen[page_num], font, 314, RESOL_Y - 20, makecol(255, 255, 0), -1, weap_name);

textprintf_ex(vscreen[page_num], font, 520, RESOL_Y - 56, makecol(255, 255, 255), -1, "Standard gun :");
textprintf_ex(vscreen[page_num], font, 720, RESOL_Y - 56, makecol(0, 255, 0), -1, "ready");
textprintf_ex(vscreen[page_num], font, 520, RESOL_Y - 46, makecol(255, 255, 255), -1,"Eradicator Beam :");
if(!beam.reload_time)
	textprintf_ex(vscreen[page_num], font, 720, RESOL_Y - 46, makecol(0, 255, 0), -1, "ready");
else textprintf_ex(vscreen[page_num], font, 720, RESOL_Y - 46, makecol(255, 0, 0), -1, "reloading");
textprintf_ex(vscreen[page_num], font, 520, RESOL_Y - 36, makecol(255, 255, 255), -1,"ASCII Garbagethrower :");
if(!asciigarbage.ammo_left && asciigarbage.delay_to_reload)
	textprintf_ex(vscreen[page_num], font, 720, RESOL_Y - 36, makecol(255, 0, 0), -1, "reloading");
if(asciigarbage.ammo_left)
	{
	rect(vscreen[page_num], 720, RESOL_Y - 36, 790, RESOL_Y - 26, makecol(127, 127, 127));
	rectfill(vscreen[page_num], 721, RESOL_Y - 35, 721 + ((float)asciigarbage.ammo_left / 50 * 68), RESOL_Y - 27, makecol(255 * (50 - (float)asciigarbage.ammo_left) / 50, 255 * (float)asciigarbage.ammo_left / 50, 0));
	}

return 0;
}

int display_beam()
{
point cur_pos = beam.first_pos;
cur_pos.x -= screen_offset.x;
cur_pos.y -= screen_offset.y;
if(beam.rest.x == 0)
	line(vscreen[page_num], cur_pos.x, cur_pos.y, cur_pos.x + 800, cur_pos.y + 800 * beam.angle, makecol(127, 0, 0));
else
	line(vscreen[page_num], cur_pos.x, cur_pos.y, cur_pos.x - 800, cur_pos.y - 800 * beam.angle, makecol(127, 00, 0));
return 0;
}

int display_garbage()
{
garbage_t * cur = first_garbage;
while(cur)
	{
	if(cur->life > 0)
		textprintf_ex(vscreen[page_num], font, cur->pos.x - screen_offset.x, cur->pos.y - screen_offset.y, makecol(255, 255, 255), makecol(0, 0, 0), "%c", cur->c);
	cur = cur->NEXT;
	}
return 0;
}

int display_all()
{
if(!page_flip)
	acquire_bitmap(vscreen[page_num]);
clear_bitmap(vscreen[page_num]);
//clear_to_color(vscreen[page_num], makecol(62, 142, 66));
set_clip_rect(vscreen[page_num], 0, 0, RESOL_X, RESOL_Y - 65);
display_background();
display_railroad();
display_enemies();
display_garbage();
if(beam.time_rng != -1) display_beam();
display_crosshair();
display_player();
set_clip_rect(vscreen[page_num] , 0, 0, RESOL_X, RESOL_Y);
display_hud();
//textprintf_ex(vscreen[page_num], font, 1, 15, makecol(255, 255, 255), makecol(0,0,0), "Cyclecount %i", cyclecount);

if(GAME_PAUSED)
	display_pause_screen();
//rect(vscreen[page_num], RESOL_X * 15 / 100, RESOL_Y * 15 / 100, RESOL_X * 85 / 100, RESOL_Y * 85 / 100, 4);
//textprintf_ex(vscreen[page_num], font, 10, 15, makecol(255, 255, 255), -1, "Screen_pos %i %i refpt %i %i tpos %i %i", screen_offset.x, screen_offset.y, player.refpt.x, player.refpt.y, tpos.x, tpos.y);
if(!page_flip)
	{
	release_bitmap(vscreen[page_num]);
	if(!is_memory_bitmap(vscreen[0]))
                vsync();
	blit(vscreen[0], screen, 0,0,0,0,RESOL_X,RESOL_Y);
	} 
else
	{
	show_video_bitmap(vscreen[page_num]);
	page_num = 1-page_num;
	}
return 0;
}

int display_pause_screen()
{
if(GAME_PAUSED & PAUSE_SCREEN)
	{
	rectfill(vscreen[page_num], RESOL_X * 0.2, RESOL_Y * 0.2, RESOL_X * 0.8, RESOL_Y * 0.8, makecol(127, 127, 127));
	rect(vscreen[page_num], RESOL_X * 0.2, RESOL_Y * 0.2, RESOL_X * 0.8, RESOL_Y * 0.8, makecol(0, 0, 255));
	textprintf_centre_ex(vscreen[page_num], font, RESOL_X * 0.5, RESOL_Y * 0.4, makecol(255, 0, 0), -1, "PAUSED");
	textprintf_centre_ex(vscreen[page_num], font, RESOL_X * 0.5, RESOL_Y * 0.5 + 12, makecol(0, 0, 0), -1, "'p' to resume");
	}
if(GAME_PAUSED & HELP_SCREEN)
	{
	display_help_screen();
	}
if(GAME_PAUSED & LOSER)
	{
	rectfill(vscreen[page_num], RESOL_X * 0.1, RESOL_Y * 0.2, RESOL_X * 0.9, RESOL_Y * 0.8, makecol(127, 127, 127));
	rect(vscreen[page_num], RESOL_X * 0.1, RESOL_Y * 0.2, RESOL_X * 0.9, RESOL_Y * 0.8, makecol(0, 0, 255));
	textprintf_centre_ex(vscreen[page_num], font, RESOL_X * 0.5, RESOL_Y * 0.4, makecol(255, 0, 0), -1, "LOSER !");
	textprintf_centre_ex(vscreen[page_num], font, RESOL_X * 0.5, RESOL_Y * 0.5 + 12, makecol(0, 0, 0), -1, "Fortunately, your miserable failure did not happen in the real world.");
	textprintf_centre_ex(vscreen[page_num], font, RESOL_X * 0.5, RESOL_Y * 0.5 + 22, makecol(0, 0, 0), -1, "Please, never apply for being Humainkind Train Keeper.");
	textprintf_ex(vscreen[page_num], font, RESOL_X * 0.2, RESOL_Y * 0.8 - 12, makecol(63, 63, 63), -1, "Escape to quit");
	}
if(GAME_PAUSED & WINNER)
	{
	rectfill(vscreen[page_num], RESOL_X * 0.1, RESOL_Y * 0.2, RESOL_X * 0.9, RESOL_Y * 0.8, makecol(127, 127, 127));
	rect(vscreen[page_num], RESOL_X * 0.1, RESOL_Y * 0.2, RESOL_X * 0.9, RESOL_Y * 0.8, makecol(0, 0, 255));
	textprintf_centre_ex(vscreen[page_num], font, RESOL_X * 0.5, RESOL_Y * 0.4, makecol(255, 0, 0), -1, "WINNER !");
	textprintf_centre_ex(vscreen[page_num], font, RESOL_X * 0.5, RESOL_Y * 0.5 + 12, makecol(0, 0, 0), -1, "Guys like you are priceless.");
	textprintf_ex(vscreen[page_num], font, RESOL_X * 0.2, RESOL_Y * 0.8 - 12, makecol(63, 63, 63), -1, "Escape to quit");
	}
return 0;
}
