/*
Copyright (c) 2006 Arthur Huillet

TINS'06 entry


Input functions
*/
#include "all_inc.h"

void main_loop()
{
extern int cyclecount;
extern int game_running;
train_advance();
generate_enemies();
if(cyclecount % 2) move_enemies();
if(!(cyclecount % 50)) detonate_bombs();
process_beam();
process_garbage();
ah_scroll_screen();
get_input();

if(life <=0)
	{
	//bad gameover screen
	log_msg(1, "Loser !");
	pause_game(); 
	GAME_PAUSED |= LOSER;
	game_paused_screen();
	resume_game();
	game_running = 0;
	}
if(current_year >= 2006)
	{ //good gameover screen
	log_msg(1, "Winner !");
	pause_game(); 
	GAME_PAUSED |= WINNER;
	game_paused_screen();
	resume_game();
	game_running = 0;
	}
}

int generate_enemies()
{
extern int cyclecount;
//if(cyclecount && !(cyclecount % (2006 - current_year)))
if(cyclecount)
	{
	int prob = (int)((20 + difficulty_level * 10) * log(current_year));
	int dice = rand() % 10000;
	//log_msg(3, "Spawning prob : %i, rand gave %i", prob, dice);
	if(dice <= prob)
	{
	point pos = tpos;
	while((abs(tpos.x - pos.x) < 400 && abs(tpos.y - pos.y) < 300))
		{
		pos.x = tpos.x + rand() % (2*RESOL_X) - RESOL_X;
		pos.y = tpos.y + rand() % (2*RESOL_Y) - RESOL_Y;
		}
	first_enemy = add_enemy(first_enemy, pos.x, pos.y, enemy_spr, 64);
	}
	}
return 0;
}

int move_enemies()
{
enemy_t * cur = first_enemy;
while(cur)
	{
	point dir = cur->pos;
	point center = train_pos->pos;
	center.x += 45;
	center.y += 45;
	dir.x -= center.x - 32;
	dir.y -= center.y - 32;
	if(dir.x < -20 && abs(dir.y) <= 20) cur->pos.x ++;
	else if(dir.x > 20 && abs(dir.y) <= 20) cur->pos.x --;
	if(dir.y < -20 && abs(dir.x) <= 20) cur->pos.y ++;
	else if(dir.y > 20 && abs(dir.x) <= 20) cur->pos.y --;
	
	if(dir.x < -20 && dir.y < -20)
		{
		if((rand() % 10) <= 7)
			cur->pos.x ++;
		if((rand() % 10) <= 7)
			cur->pos.y ++;
		}
	
	if(dir.x < -20 && dir.y > 20)
		{
		if((rand() % 10) <= 7)
			cur->pos.x ++;
		if((rand() % 10) <= 7)
			cur->pos.y --;
		}
	
	if(dir.x > 20 && dir.y < -20)
		{
		if((rand() % 10) <= 7)
			cur->pos.x --;
		if((rand() % 10) <= 7)
			cur->pos.y ++;
		}
		
	if(dir.x > 20 && dir.y > 20)
		{
		if((rand() % 10) <= 7)
			cur->pos.x --;
		if((rand() % 10) <= 7)
			cur->pos.y --;
		}
		
	if(abs(dir.x) < 40 && abs(dir.y) < 40)
		{ //lose fate points
		life --;
		enemy_t * nexte = cur->NEXT;
		first_enemy = delete_enemy(cur);
		cur = nexte;
		}
	else
		cur = cur->NEXT;
	}
return 0;
}

void get_input()
{
extern int game_running;
extern int cyclecount;
if(key[KEY_ESC])
	game_running = 0;
if(key[KEY_LEFT]) go_left();
if(key[KEY_RIGHT]) go_right();
if(key[KEY_UP]) go_up();
if(key[KEY_DOWN]) go_down();
if(key[KEY_P]) { pause_game(); GAME_PAUSED |= PAUSE_SCREEN; game_paused_screen(); resume_game(); }
if(key[KEY_F1]) { pause_game(); GAME_PAUSED |= HELP_SCREEN; help_screen(); resume_game(); }
/*if(key[KEY_PLUS_PAD]) current_year++;
if(key[KEY_MINUS_PAD]) current_year--;*/
if(key[KEY_BACKSPACE] && !(last_mouse_b & 4)) { difficulty_level = (difficulty_level + 1) % 4; last_mouse_b |= 4; }
if(!key[KEY_BACKSPACE]) last_mouse_b &= ~4;

if(key[KEY_SPACE] || key[KEY_RSHIFT]) 
	{
	bomb_t * target = bomb_near_player(player.refpt.x, player.refpt.y);
	if(target)
		{
			if(defuse_time == -1)
				{
				defuse_time = 80;
				defuse_bomb = target;
				}
			else defuse_time --;
			if(defuse_time <= 0)
				{
				defuse_time = -1;
				first_bomb = delete_bomb(target);
				}	
			//log_msg(3, "Defuse time %i", defuse_time);
		}
	}
if(!key[KEY_SPACE] && !key[KEY_RSHIFT])
	{
	defuse_time = -1;	
	}
	
if(mouse_b & 1)
	{
	if(!(last_mouse_b & 1))
		{ //then this is a click
		if(player.weap == 0)
			{
			enemy_t * target = enemy_under_cursor(crosshair.offset_rp.x + player.refpt.x, crosshair.offset_rp.y + player.refpt.y);
			first_enemy = delete_enemy(target);
			}
		if(player.weap == 1) //eradicator beam !!
			{
			if(!beam.reload_time)
				fire_beam();
			else {
				enemy_t * target = enemy_under_cursor(crosshair.offset_rp.x + player.refpt.x, crosshair.offset_rp.y + player.refpt.y);
				first_enemy = delete_enemy(target);
				}
			}
		}
	if(player.weap == 2 && asciigarbage.ammo_left > 0 && !(cyclecount % 3))
		{
		first_garbage = add_garbage(first_garbage, crosshair.offset_rp.x, crosshair.offset_rp.y);
		asciigarbage.ammo_left --;
		asciigarbage.is_used = 1;
		if(asciigarbage.ammo_left == 0)
			{
			asciigarbage.delay_to_reload = 80;
			player.weap = 1;
			}
		}
	last_mouse_b |= 1;
	}
if(!(mouse_b &1)) 
	{
	last_mouse_b &= ~1;
	asciigarbage.is_used = 0;
	}
	

if(mouse_b & 2)
	{
	if(!(last_mouse_b & 2))
		{
		if(player.weap == 2)
			player.weap = 1;
		else if(player.weap == 1) player.weap = 2;
		}
	last_mouse_b |= 2;
	}
if(!(mouse_b & 2))
	{
	last_mouse_b &= ~2;	
	}
	
/*crosshair*/
if(cyclecount % 2)
	{
	int mouse_x, mouse_y;
	int x0 = (PLAYER_SIZE - 1) * 4; //y0 is the same !
	get_mouse_mickeys(&mouse_x, &mouse_y);
	int var_x = crosshair.offset_rp.x - x0 + mouse_x;
	int var_y = crosshair.offset_rp.y - x0 + mouse_y;
	//log_msg(3, "Relative crosshair position : %i, %i\tMouse variation %i, %i\tVar : %i, %i", crosshair.offset_rp.x, crosshair.offset_rp.y, mouse_x, mouse_y, var_x, var_y);
	#define DIST(X, Y) (sqrt(X * X + Y * Y))
	float r0 = 200;
	float r = DIST(var_x, var_y);
	if(r > r0)
		{
		var_x = (float)var_x * r0 / r;
		var_y = (float)var_y * r0 / r;
		}
	crosshair.offset_rp.x = var_x + x0;
	crosshair.offset_rp.y = var_y + x0;
	}
}


void pause_game()
{
extern void increment_run_game_cycle();
remove_int(increment_run_game_cycle);
log_msg(1, "Game paused");
GAME_PAUSED |= 1;
clear_keybuf();
}

void game_paused_screen()
{
char end = 0;
extern int game_running;
while(key[KEY_P]) rest(10);
while(!end)
	{	
	display_all();
	if(key[KEY_P] || key[KEY_ESC]) end = 1;
	rest(10);
	}
if(key[KEY_ESC]) game_running = 0;
}


void resume_game()
{
extern void increment_run_game_cycle();
install_int_ex(increment_run_game_cycle, BPS_TO_TIMER(100));
log_msg(1, "Game resumed");
GAME_PAUSED = 0;
while(key[KEY_P] || key[KEY_F1]) rest(10);
}



int go_left()
{
for(int i = 0; i < 2; i++)
	{
	if(!is_in_bounds(player.refpt.x - 1, player.refpt.y))
		return i;
	player.refpt.x --;
	}	
return 1;
}

int go_right()
{
for(int i = 0; i < 2; i++)
	{	
	if(!is_in_bounds(player.refpt.x + 1, player.refpt.y))
		return i;
	player.refpt.x ++;
	}
return 1;
}

int go_up()
{
for(int i = 0; i < 2; i++)
	{
	if(!is_in_bounds(player.refpt.x, player.refpt.y  - 1))
		return i;
	player. refpt.y --;
	}
return 1;
}

int go_down()
{
for(int i = 0; i < 2; i++)
	{
	if(!is_in_bounds(player.refpt.x, player.refpt.y + 1))
		return i;
	player.refpt.y ++;
	}	
return 1;
}

int is_in_bounds(unsigned int x, unsigned int y)
{
/*train deadzone computing : if train is less than 800px on x AND less than 600 px on y, position is allowed*/
if(abs(tpos.x - x) < 710 && abs(tpos.y - y) < 510)
	return 1;
return 0;
}

void train_advance()
{
extern int cyclecount;
if(!(cyclecount % 8))
	{
	switch(fixtoi(train_angle))
		{
		case 0 : tpos.x ++; break;
		case 192 : tpos.y --; break;
		case 64: tpos.y++; break;
		case 224: tpos.x ++; tpos.y --; break;
		case 32 : tpos.x ++; tpos.y ++; break;
		}
	}
if(!(cyclecount % 40))
	current_year ++;
if(cyclecount % 400)
	return;
train_pos = train_pos->NEXT;

tpos = train_pos->pos;
switch(train_pos->part)
	{	
	/*case '-' : tpos.y += 45; tpos.x += 45; train_angle = 0; break;
	case '|': tpos.x += 45; tpos.y += 40; train_angle=itofix(192); break;
	case 'V': tpos.x += 48; tpos.y += 45; train_angle=itofix(64); break;
	case '/': tpos.y += 45; tpos.x += 45; train_angle=itofix(224); break;
	case '\\' : tpos.x += 40; tpos.y += 40; train_angle=itofix(32); break;*/
	case '-' : tpos.y += 45; tpos.x += 23; train_angle = 0; break;
	case '|': tpos.x += 45; tpos.y += 60; train_angle=itofix(192); break;
	case 'V': tpos.x += 48; tpos.y += 23; train_angle=itofix(64); break;
	case '/': tpos.y += 60; tpos.x += 23; train_angle=itofix(224); break;
	case '\\' : tpos.x += 20; tpos.y += 20; train_angle=itofix(32); break;
	}
}

int ah_scroll_screen()
{
/*three things to do
*/
//keep player in bounds
if((tpos.x - player.refpt.x) > 700)
	player.refpt.x ++;
if((tpos.x - player.refpt.x) < -700)
	player.refpt.x --;
if((tpos.y - player.refpt.y) < -500)
	player.refpt.y --;
if((tpos.y - player.refpt.y) > 500)
	player.refpt.y ++;

//scroll screen if player outside of deadzone
point pldzone_top;
point pldzone_btm;
pldzone_top.x = RESOL_X * 18 / 100;
pldzone_top.y = RESOL_Y * 18 / 100;
pldzone_btm.x = RESOL_X * 82 / 100;
pldzone_btm.y = (RESOL_Y - 64)* 82 / 100;
if(player.refpt.x >= pldzone_btm.x + screen_offset.x)
	screen_offset.x +=2;
if(player.refpt.y >= pldzone_btm.y + screen_offset.y)
	screen_offset.y +=2;
if((player.refpt.x <= pldzone_top.x + screen_offset.x) && screen_offset.x > 0)
	screen_offset.x -=2;
if(player.refpt.y <= pldzone_top.y + screen_offset.y)
	screen_offset.y -=2;


//scroll screen if train outside of deadzone
point trdzone_top;
point trdzone_btm;
trdzone_top.x = RESOL_X * 8 / 100;
trdzone_top.y = RESOL_Y * 8 / 100;
trdzone_btm.x = RESOL_X * 92/100;
trdzone_btm.y = (RESOL_Y - 64) * 92/100;
if(tpos.x >= trdzone_btm.x + screen_offset.x)
	screen_offset.x ++;
if(tpos.y >= trdzone_btm.y + screen_offset.y)
	screen_offset.y ++;
if(tpos.x <= trdzone_top.x + screen_offset.x)
	screen_offset.x --;
if(tpos.y <= trdzone_top.y + screen_offset.y)
	screen_offset.y --;
return 0;
}

enemy_t * add_enemy(enemy_t * first, int x, int y, BITMAP * spr, short int size)
{
enemy_t * new_obj = (enemy_t *)calloc(1, sizeof(enemy_t));
log_msg(2, "Adding enemy");
new_obj->pos.x = x;
new_obj->pos.y = y;
new_obj->spr = spr;
new_obj->size = size;
new_obj->NEXT = first;
if(first)
	{
	first->PREV = new_obj;
	}
return new_obj;
}

int free_enemies(enemy_t * first)
{
enemy_t * cur = first;
while(cur)
	{
	cur = first->NEXT;
	free(first);
	first = cur;
	}
return 0;
}

enemy_t * enemy_under_cursor(int x, int y)
{
enemy_t * cur = first_enemy;
while(cur)
	{
	if(x >= cur->pos.x && x <= cur->pos.x + cur->size)
		if(y >= cur->pos.y && y <= cur->pos.y + cur->size)
			return cur;
	cur = cur->NEXT;
	}
return NULL;
}

bomb_t * bomb_near_player(int x, int y)
{
bomb_t * cur = first_bomb;
while(cur)
	{
	point center = cur->pos;
	center.x += cur->size / 2;
	center.y += cur->size / 2;
	if(abs(x - center.x) < 30 && abs(y - center.y) < 30)
		return cur;
	cur = cur->NEXT;
	}
return NULL;
}

enemy_t * delete_enemy(enemy_t * target)
{
if(!target) return first_enemy;
if(target->PREV) (target->PREV)->NEXT = target->NEXT;
if(target->NEXT) (target->NEXT)->PREV = target->PREV;

if(target == first_enemy)
	{	
	enemy_t * tor = target->NEXT;
	free(target);
	return(tor);
	}
	
free(target);
return first_enemy;
}

bomb_t * delete_bomb(bomb_t * target)
{
if(!target) return first_bomb;
if(target->PREV) (target->PREV)->NEXT = target->NEXT;
if(target->NEXT) (target->NEXT)->PREV = target->PREV;
if(!target->NEXT) last_bomb = target->PREV;
	
if(target == first_bomb)
	{	
	bomb_t * tor = target->NEXT;
	free(target);
	return(tor);
	}
	
free(target);
return first_bomb;
}

void detonate_bombs()
{
bomb_t * cur = last_bomb;
bomb_t * nxt = NULL;
while((cur) && (abs(cur->pos.x - tpos.x) < 200))
	{
	nxt = cur->PREV;
	if(cur->spr == bombexp_spr)
		{
		first_bomb = delete_bomb(cur);
		}
	if((abs(cur->pos.x - tpos.x) < 50) && (abs(cur->pos.y - tpos.y) < 50))
		{
		cur->spr = bombexp_spr;
		cur->pos.x -= 85;
		cur->pos.y -= 85;
		life -= 4;
		}
	cur = nxt;
	}
}

void fire_beam()
{
beam.time_rng = 20;
beam.first_pos = player.refpt;
//beam.first_pos.x += crosshair.offset_rp.x;
//beam.first_pos.y += crosshair.offset_rp.y;
beam.angle = (float)crosshair.offset_rp.y / (float)crosshair.offset_rp.x;
if(crosshair.offset_rp.x >= 0)
	beam.rest.x = 0;
else beam.rest.x = - 0.05;
beam.rest.y = 0;
log_msg(3, "Beam fired !");
beam.reload_time = 160;
}

void process_beam()
{
if(beam.reload_time > 0) beam.reload_time --;
if(beam.time_rng == -1)
	return;
int pcount = 0;
point cur_pos = beam.first_pos;
if(beam.time_rng == 0) beam.time_rng = -1;
else beam.time_rng --;
while(pcount < 800)
	{
	if(!isnan(beam.angle))
		{
		if(beam.rest.y >= 0.5)
			{
			cur_pos.y ++;
			beam.rest.y --;
			}
		if(beam.rest.y <= -0.5)
			{
			cur_pos.y --;
			beam.rest.y ++;
			}
		if(beam.rest.x == 0)
			{
			cur_pos.x ++;
			cur_pos.y += rintf(beam.angle);
			beam.rest.y -= rintf(beam.angle) - beam.angle;
			}
		else {
			cur_pos.x --;
			cur_pos.y -= rintf(beam.angle);
			beam.rest.y += rintf(beam.angle) - beam.angle;
			}
		}
	else cur_pos.y ++;
	if(pcount % 2)
		{
		enemy_t * target = enemy_under_cursor(cur_pos.x, cur_pos.y);
		if(target) first_enemy = delete_enemy(target);
		}
	pcount ++;
	}
}


void process_garbage()
{
extern int cyclecount;
if(asciigarbage.delay_to_reload)
	asciigarbage.delay_to_reload--;
else
	if(asciigarbage.ammo_left < 50 && !asciigarbage.is_used && !(cyclecount % 15))
	{
	asciigarbage.ammo_left += 1;
	}
	
garbage_t * cur = first_garbage;
while(cur)
	{
	garbage_t * next = cur->NEXT;
		if(cur->life > 0)
		{
		cur->life--;
		if(cur->rest.y >= 0.5)
				{
				cur->pos.y ++;
				cur->rest.y --;
				}
		if(cur->rest.y <= -0.5)
				{
				cur->pos.y --;
				cur->rest.y ++;
				}
		if(cur->rest.x >= 0.5)
				{
				cur->pos.x ++;
				cur->rest.x --;
				}
		if(cur->rest.x <= -0.5)
				{
				cur->pos.x --;
				cur->rest.x ++;
				}
		cur->pos.x += rintf(cur->dx);
		cur->rest.x -= rintf(cur->dx) - cur->dx;
		cur->pos.y += rintf(cur->dy);
		cur->rest.y -= rintf(cur->dy) - cur->dy;
		extern int cyclecount;
		if(!(cyclecount % 10))
			{
			enemy_t * target = enemy_under_cursor(cur->pos.x, cur->pos.y);
			if(target) 
				{
				first_enemy = delete_enemy(target);
				cur->life = 0;
				}
			}
		}
	if(cur->life == 0)
		first_garbage = delete_garbage(cur);
	cur = next;
	}
}


garbage_t * add_garbage(garbage_t * first, int x, int y)
{
garbage_t * new_obj = first_garbage;
log_msg(3, "Adding garbage !");
new_obj = (garbage_t *)calloc(1, sizeof(garbage_t));

	
new_obj->pos.x = player.refpt.x;
new_obj->pos.y = player.refpt.y;
new_obj->c = 33 + (rand() % 89);
new_obj->life = 240;

new_obj->NEXT = first;
float slope = (float)y / (float)x;
float angle;
float max_angle = atan2((float)(y), (float)(x)) + 0.5;
float min_angle = atan2((float)(y), (float)(x)) - 0.5;
angle = min_angle + (max_angle - min_angle) * (rand() % 100) / 100;

//we have dy = (slope + offset) dx
//we want sqrt(dx ** 2+ dy ** 2) = 1 which means dy = a dx and dx = 1/sqrt(a**2 + 1)
slope = tan(angle);
if(!isnan(slope))
	{
	new_obj->dx = 3 / sqrt((slope) * (slope) + 1);
	new_obj->dy = new_obj->dx * (slope);
	if((angle < -3.1415926 / 2 && angle > -(3*3.1415926/2)) || (angle > 3.1415926 / 2 && angle < (3*3.1415926/2)))
		{
		new_obj->dx = -new_obj->dx;
		new_obj->dy = -new_obj->dy;
		}
	}
//log_msg(3, "Angle is %f, max %f, min %f => slope %f, dx %f dy %f", angle, max_angle, min_angle, slope, new_obj->dx, new_obj->dy);

return new_obj;
}

garbage_t * delete_garbage(garbage_t * target)
{
garbage_t * cur = first_garbage;
while(cur && target != first_garbage)
	{
	if(cur->NEXT == target)
		{
		cur->NEXT = target->NEXT;
		free(target);
		return first_garbage;
		}
	cur = cur->NEXT;
	}
	
if(target == first_garbage)
	{
	garbage_t * tor = target->NEXT;
	free(first_garbage);
	return tor;
	}
	
return first_garbage;
}

int free_garbage(garbage_t * first)
{
garbage_t * cur = first;
while(cur)
	{
	cur = first->NEXT;
	free(first);
	first = cur;
	}
return 0;
}


