/*
Copyright (c) 2006 Arthur Huillet

TINS'06 entry


Objects definitions, etc.
*/


unsigned int RESOL_X; /*screen resolution*/
unsigned int RESOL_Y;

unsigned int current_year; /*aka score !*/
int GAME_PAUSED;

typedef struct {
	int x, y;
} point;

#define PLAYER_SIZE 6
typedef struct {
	point refpt;
	char draw[PLAYER_SIZE - 1][PLAYER_SIZE];
	BITMAP * sprite;
	char weap;
} player_t;


typedef struct {
	point offset_rp;
} crosshair_t;

player_t player;
crosshair_t crosshair;

BITMAP * vscreen[2]; /*virtual screen*/

typedef struct railpart_ {
	char part;
	struct railpart_ * NEXT;
	struct railpart_ * PREV;
	point pos;
	} railpart;
	
railpart * train_pos; //train position
railpart * railroad; //whole railroad
railpart * rail_pieces;

struct {
	BITMAP * dash;
	BITMAP * slash;
	BITMAP * antislash;
	BITMAP * pipe;
} part_sprites;

typedef struct enemy_ {
	point pos;
	BITMAP * spr;
	short int size;
	struct enemy_ * NEXT;
	struct enemy_ * PREV;
	} enemy_t;

typedef enemy_t bomb_t;
	
struct {
	point first_pos;
	short int time_rng;
	float angle;
	struct { float x; float y; } rest;
	short int reload_time;
	} beam;
	
struct {
	short int ammo_left;
	short int delay_to_reload;
	char is_used;
	} asciigarbage;
	
typedef struct garbage_ {
	point pos;
	float dx;
	float dy;
	struct { float x; float y; } rest;
	char c;
	char used;
	int life;
	struct garbage_ * NEXT;
	} garbage_t;
	
point rail_screen_pos; //position of the first rail part on the screen
point tpos; //position of the train on the screen
fixed train_angle;
point screen_offset;

enemy_t * first_enemy;
garbage_t * first_garbage;
bomb_t * first_bomb;
bomb_t * last_bomb;
bomb_t * defuse_bomb;

BITMAP * train;
BITMAP * bground;
BITMAP * enemy_spr;
BITMAP * bomb_spr;
BITMAP * bombexp_spr;
int life; //"fate points"
int defuse_time;
char last_mouse_b;
int difficulty_level;


